/*
  IT COOKBOOK MINI PROJECT
  PROGRAM NAME: MEMBER.C
*/
#include <stdio.h>
#define FALSE        0
#define TRUE         1
/*    */
typedef struct FILE_HEADER {
  char pname[10];    /* α׷ ̸ */
  char version[10];  /* α׷  */
  long recnt;        /* ڵ   */
} DFH;
/* ũ  ȸ ڵ   */
typedef struct MEMBER {
   int  no;           /* Ϸùȣ */
   char usrid[10];    /* ȸID */
   char paswd[10];    /* йȣ */
   char name[20];     /* ȸ ̸ */
   char sex[2];       /*  */
   int  age;          /*  */
   char position[20]; /*  */
   char company[30];  /* ȸ */
   char address[40];  /* ּ */
   char zipcode[7];   /* ȣ */
   char tel[15];      /* ȭȣ */
   char cel[15];      /* ޴ ȣ */
} MEMBER_REC;
/*     */
typedef struct INDEX {
   char usrid[10];  /* ȸID */
   long offset;     /*  Ͽ  */
   char flag;       /*  flag: 'D'  ڵ */
} INDEX_REC;

char *datfile = "member.dat";  /*    */
char *idxfile = "member.idx";   /*    */
/*  Լ  */
void delete_member();
int  disk_comp(FILE* fp, long i, long j);
void disk_swap(FILE *fp, long i, long j);
void display_member(MEMBER_REC *m);
long fbin_search(const char* key, long n, FILE* fp);
int  find_member(const char* usrid, MEMBER_REC *m);
void fqsort(FILE *fp, long left, long right);
unsigned long get_offset(const char* usrid);
long get_recount();
void indexing();
void init_file();
void insert_member();
void list_member();
void modify_member();
void printTitle(void);
int  save_data(MEMBER_REC *m);
void search_member();
int  set_delete(const char* usrid);
void view_help();
/*  Լ */
int main()
{
	char ch, quit=FALSE;

	while(TRUE) {
	  clrscr();   /* ȭ  */
	  printTitle();   /* α׷ ŸƲ  */
	  printf("I) ȸ\n");
	  printf("M) ȸ \n");
	  printf("D) ȸ \n");
	  printf("S) ȸ˻\n");
	  printf("L) ȸ\n");
	  printf("N) ýʱȭ\n");
	  printf("X) ڷ\n");
	  printf("H) \n");
	  printf("Q) \n\n");
	  ch = toupper(getch());
	  printf("\n");
	  switch (ch) {
		case 'I': insert_member(); break; /* ȸ */
		case 'M': modify_member(); break; /* ȸ */
		case 'D': delete_member(); break; /* ȸ */
		case 'S': search_member(); break; /* ȸ˻ */
		case 'L': list_member(); break;   /* ȸ */
		case 'N': init_file(); break;     /* ʱȭ */
		case 'X': indexing(); break;      /* ڷ */
		case 'H': view_help(); break;     /*  */
		case 'Q': quit = TRUE; break;
	  }
	  if (quit) break;
	}
	return 0;
}
/* ý ʱȭ( ϰ    )Ѵ. */
void init_file()
{
	DFH dfh = {"MMS","0.9",0}; /*    */
	FILE* fp;
	dfh.version[3] = 0x1a; /* EOF  */
	if ((fp = fopen(datfile, "wb")) == NULL)
	{
	  printf("Error : can't make data file %s \n", datfile);
	  exit(0);
	} else {
	  fwrite(&dfh, sizeof(dfh), 1, fp);
	}
	fclose(fp);
	if ((fp = fopen(idxfile, "wb")) == NULL)
	{
	  printf("Error : can't make index file %s \n", idxfile);
	  exit(0);
	}
	fclose(fp);
}
/* ű ȸ  Է */
void insert_member()
{
  MEMBER_REC m;
  printf("ȸ ⺻  ԷϽʽÿ...\n");
  printf("\n>  ȣ : "); scanf("%d", &m.no); fflush(stdin);
  printf("\n> ȸID : "); gets(m.usrid);
  printf("\n> йȣ : "); gets(m.paswd);
  printf("\n>   : ");  gets(m.name);
  printf("\n>   : ");  strcpy(m.sex, gets(m.sex));
  printf("\n>   : ");   scanf("%d", &m.age); fflush(stdin);
  printf("\n>   : "); gets(m.position);
  printf("\n> ȸ : "); gets(m.company);
  printf("\n>   : "); gets(m.address);
  printf("\n> ȣ : "); gets(m.zipcode);
  printf("\n> ȭȣ : "); gets(m.tel);
  printf("\n> ޴ : "); gets(m.cel);
  printf("\nS), M), Q) : ");
  switch ( toupper(getch()) )
  {
	  case 'S': save_data(&m); break;
	  case 'M': return;
	  case 'Q': exit(0);
  }
}
/* ڵ   ȯѴ. */
long get_recount()
{
  FILE* fp;
  DFH dfh;
  fp = fopen(datfile, "rb");
  fseek(fp, 0L, SEEK_SET);
  fread(&dfh, sizeof(DFH), 1, fp);
  fclose(fp);
  return dfh.recnt;
}
/* ũ  2 ڵ带 ٲپ Ѵ. */
void disk_swap(FILE *fp, long i, long j)
{
  INDEX_REC idx1, idx2;
  if (i == j) return;
  /* read idx1 */
  fseek(fp, sizeof(INDEX_REC)*i, SEEK_SET);
  fread(&idx1, sizeof(INDEX_REC), 1, fp);
  /* read idx2 */
  fseek(fp, sizeof(INDEX_REC)*j, SEEK_SET);
  fread(&idx2, sizeof(INDEX_REC), 1, fp);

  /* write idx2 on the positon of idx1 */
  fseek(fp, sizeof(INDEX_REC)*i, SEEK_SET);
  fwrite(&idx2, sizeof(INDEX_REC), 1, fp);
  /* write idx1 on the positon of idx2 */
  fseek(fp, sizeof(INDEX_REC)*j, SEEK_SET);
  fwrite(&idx1, sizeof(INDEX_REC), 1, fp);
}
/* ũ ϵ   ڵ带 о  ID Ѵ. */
int disk_comp(FILE* fp, long i, long j)
{
  INDEX_REC idx1, idx2;
  /* read idx1 */
  fseek(fp, sizeof(INDEX_REC)*i, SEEK_SET);
  fread(&idx1, sizeof(INDEX_REC), 1, fp);
  /* read idx2 */
  fseek(fp, sizeof(INDEX_REC)*j, SEEK_SET);
  fread(&idx2, sizeof(INDEX_REC), 1, fp);
  /* compare usrid */
  return strcmp(idx1.usrid, idx2.usrid);
}
/*   ˰  ũ ڵ带 Ѵ. */
void fqsort(FILE *fp, long left, long right)
{
  long i, last;
  if (left >= right) return;
  disk_swap(fp, left, (left+right)/2);
  last = left;
  for (i=left+1; i<=right; i++)
  {
	if (disk_comp(fp, i, left) < 0)
	  disk_swap(fp, ++last, i);
  }
  disk_swap(fp, left, last);
  fqsort(fp, left, last-1);
  fqsort(fp, last+1, right);
}
/* ĵ ͸  ˻  ͸ ã´. */
long fbin_search(const char* key, long n, FILE* fp)
{
  int cond;
  long low = 0L, high = n, mid;
  INDEX_REC idx;

  while (low < high)
  {
	mid = (low + high) / 2;
	fseek(fp, sizeof(INDEX_REC)*mid, SEEK_SET);
	fread(&idx, sizeof(INDEX_REC), 1, fp);
	cond = strcmp(key, idx.usrid);
	if (cond < 0) high = mid;
	else if (cond > 0) low = mid + 1;
	else return mid; /* return the index of searched data */
  }
  return EOF;  /* Not found */
}
/* ü m  ȸ ũ  Ѵ. */
int save_data(MEMBER_REC *m)
{
  FILE *fp;
  DFH dfh;
  INDEX_REC idx;
  unsigned long offset = 0L;

  fp = fopen(datfile, "rb+");
  if (!fp) {
	fprintf(stderr, "File open error : %s\n", datfile);
	exit(0);
  }
  fseek(fp, 0L, SEEK_SET);
  fread(&dfh, sizeof(DFH), 1, fp);  /* read file header */
  /* seek the postion to write */
  offset = sizeof(MEMBER_REC)*dfh.recnt + sizeof(DFH); /* offset from first */
  fseek(fp, offset, SEEK_SET);
  fwrite(m, sizeof(MEMBER_REC), 1, fp);
  fflush(fp);
  dfh.recnt++;  /* increase record count and then write header */
  fseek(fp, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fp); /* write head for updating recnt */
  fclose(fp);

  strcpy(idx.usrid, m->usrid);  /* copy usrid to the field of idx file */
  idx.offset = offset;          /* offset to datfile */
  idx.flag = '\0';              /* deleting flag initial value */
  fp = fopen(idxfile, "rb+");
  if (!fp) {
	fprintf(stderr, "File open error : %s\n", datfile);
	exit(0);
  }
  fseek(fp, sizeof(INDEX_REC)*(dfh.recnt-1), SEEK_SET);
  fwrite(&idx, sizeof(INDEX_REC), 1, fp); /* write index */
  fflush(fp);

  fqsort(fp, 0, dfh.recnt-1);  /* quick sort index on the disk */
  fclose(fp);

  printf("\n ϷǾϴ...\n");
  return TRUE;
}
/* ȸ  Ѵ */
void modify_member()
{
  FILE* fp;
  MEMBER_REC m;
  char usrid[10], field[20];
  int found, i, n;

  printf("\n  ID ԷϽÿ : ");
  gets(usrid);
  found = find_member(usrid, &m);
  if (!found) {
	printf("can't not found %s ...\n", usrid); getch();
	return;
  }
  printf("\n");
  display_member(&m);
  printf(" ׸ ϼ : ");
  scanf("%d", &n);
  fflush(stdin);
  printf("͸ Էϼ : ");
  if (n == 4)
	scanf("%d\n", &i);
  else
	gets(field);

  switch (n) {
	case 1 : strcpy(m.paswd, field); break;
	case 2 : strcpy(m.name, field); break;
	case 3 : strcpy(m.sex, toupper(field)); break;
	case 4 : m.age = i; break;
	case 5 : strcpy(m.position, field); break;
	case 6 : strcpy(m.company, field); break;
	case 7 : strcpy(m.address, field); break;
	case 8 : strcpy(m.zipcode, field); break;
	case 9 : strcpy(m.tel, field); break;
	case 10 : strcpy(m.cel, field); break;
  }
  /* write modifed record to the data file */
  fp = fopen(datfile, "rb+");
  fseek(fp, get_offset(usrid), SEEK_SET);
  fwrite(&m, sizeof(MEMBER_REC), 1, fp);
  fclose(fp);
  printf(" ϷǾϴ...\n");
}
/* ü m  ȸ  ȭ鿡 Ѵ. */
void display_member(MEMBER_REC *m)
{
  printf(">  ȣ      : %d\n", m->no);
  printf("> ȸID     : %s\n", m->usrid);
  printf(" 1. йȣ : %s\n", m->paswd);
  printf(" 2.      : %s\n", m->name);
  printf(" 3.      : %s\n", m->sex);
  printf(" 4.      : %d\n", m->age);
  printf(" 5.      : %s\n", m->position);
  printf(" 6. ȸ   : %s\n", m->company);
  printf(" 7.      : %s\n", m->address);
  printf(" 8. ȣ : %s\n", m->zipcode);
  printf(" 9. ȭȣ : %s\n", m->tel);
  printf("10. ޴   : %s\n", m->cel);
}
/*    ÷׸ ƮϿ   ڵ Ѵ. */
int set_delete(const char* usrid)
{
  FILE* fp;
  INDEX_REC idx;
  long n;

  fp = fopen(idxfile, "rb+");
  n = fbin_search(usrid, get_recount(), fp);
  if (n == EOF) {
	fclose(fp);
	return FALSE;
  }

  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fread(&idx, sizeof(INDEX_REC), 1, fp);
  idx.flag = 'D';  /* mark 'D' means it's deleted.. */
  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fwrite(&idx, sizeof(INDEX_REC), 1, fp);

  fclose(fp);
  return TRUE;
}
/* ش ȸ ڵ尡 ġ offset ȯѴ.  */
unsigned long get_offset(const char* usrid)
{
  FILE* fp;
  INDEX_REC idx;
  long n;

  fp = fopen(idxfile, "rb+");
  n = fbin_search(usrid, get_recount(), fp);
  if (n == EOF) {
	fclose(fp);
	return EOF;
  }

  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fread(&idx, sizeof(INDEX_REC), 1, fp);
  fclose(fp);

  return idx.offset;
}
/* ȸ ڵ带 Ѵ */
void delete_member()
{
  FILE* fp;
  MEMBER_REC m;
  char usrid[10];
  int found;

  printf("\n  ID ԷϽʽÿ : ");
  gets(usrid);
  found = find_member(usrid, &m);
  if (!found) {
	printf("%s  ã  ϴ.\n", usrid);
	return;
  }
  printf("\n");
  display_member(&m);
  printf("Ͻðڽϱ ?(y/n) : ");
  switch (toupper(getch())) {
	case 'N': return;
	case 'Y':
	  if (set_delete(usrid))
		printf("Ǿϴ...\n");
	  break;
  }
}
/* ȸID  ˻ ڵ带 ü m  ȯѴ. */
int find_member(const char* usrid, MEMBER_REC *m)
{
  FILE* fp;
  INDEX_REC idx;
  long n;

  fp = fopen(idxfile, "rb");
  n = fbin_search(usrid, get_recount(), fp);
  if (n == EOF) {
	fclose(fp);
	return FALSE;
  }

  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fread(&idx, sizeof(INDEX_REC), 1, fp);
  fclose(fp);

  if (idx.flag == 'D') return FALSE;  /* deleted data */

  fp = fopen(datfile, "rb");
  fseek(fp, idx.offset, SEEK_SET);
  fread(m, sizeof(MEMBER_REC), 1, fp);
  fclose(fp);

  return TRUE;
}
/* ȸID ̿Ͽ ϵ ȸ ˻Ѵ */
void search_member()
{
  MEMBER_REC m;
  char usrid[10];
  int found;

  printf("\n˻  ID ԷϽʽÿ : ");
  gets(usrid);
  found = find_member(usrid, &m);
  if (!found) {
	printf("ڸ ã  ϴ...\n");
	getch();
	return;
  }
  printf("\n");
  display_member(&m);
  printf("M), Q) : ");
  switch ( toupper(getch()) )
  {
	  case 'M': return;
	  case 'Q': exit(0);
  }
}
/* ڷ Ѵ. Ͽ   ڵ ŷ('D') */
/* ڵ带 Ͽ ã  ϰ ο ϰ  */
/*   Ѵ. */
void indexing()
{
  FILE *fpi, *fpinew;
  FILE *fpd, *fpdnew;
  INDEX_REC idx;
  MEMBER_REC m;
  DFH dfh = {"MMS", "0.9", 0};
  long nioff = 0L, ndoff = 0L, i, nrec, wcnt=0L;
  char* newidxfile = "nmember.idx";
  char* newdatfile = "nmember.dat";
  dfh.version[3] = 0x1a; /* EOF  */

  fpi    = fopen(idxfile, "rb");        /*    */
  fpd    = fopen(datfile, "rb");        /*    */
  fpinew = fopen(newidxfile, "wb+");    /*     */
  fpdnew = fopen(newdatfile, "wb+");    /*     */

  /*    Ͽ  . */
  fseek(fpdnew, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fpdnew);
  
  nrec = get_recount();
  for(i=0; i<nrec; i++)
  {
	/*    о */
	fseek(fpi, sizeof(INDEX_REC)*i, SEEK_SET);
	fread(&idx, sizeof(INDEX_REC), 1, fpi);
	if (idx.flag != 'D') {  /*  ڵ尡 ƴϸ ο Ͽ Ѵ. */
	  /*   Ͽ ڵ带   */
	  fseek(fpd, idx.offset, SEEK_SET);
	  fread(&m, sizeof(MEMBER_REC), 1, fpd);
	  /* ο  Ͽ . */
	  ndoff = sizeof(MEMBER_REC) * wcnt + sizeof(DFH);  /* ο offset  */
	  fseek(fpdnew, ndoff, SEEK_SET);
	  fwrite(&m, sizeof(MEMBER_REC), 1, fpdnew); /*  Ͽ ڵ带  */
	  /*    Ͽ ش  ڵ offset Բ  д. */
	  idx.offset = ndoff;
	  nioff = sizeof(INDEX_REC) * wcnt;  
	  fseek(fpinew, nioff, SEEK_SET);
	  fwrite(&idx, sizeof(INDEX_REC), 1, fpinew);  
	  wcnt++;   /*  ڵ  Ѵ. */
	}
  }
  /*   ڵ带 ϰ  ϵ ڵ    */
  dfh.recnt = wcnt;  /*   ڵ  */
  fseek(fpdnew, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fpdnew);

  fflush(NULL);
  fclose(fpi);
  fclose(fpd);
  fclose(fpinew);
  fclose(fpdnew);

  /*   ϰ ο Ϸ üѴ. */
  printf("ڷḦ ϰ ֽϴ...\n");
  if (remove(idxfile) == 0)
	printf("Removed old index file %s.\n", idxfile);
  else
	perror("remove error!");
  if (remove(datfile) == 0)
	printf("Removed old data file %s.\n", datfile);
  else
	perror("remove error!");
  /* Rename the newly generated file */
  if (rename(newidxfile, idxfile) == 0)
	 printf("Renamed %s to %s.\n", newidxfile, idxfile);
  else
	 perror("rename error!");
  if (rename(newdatfile, datfile) == 0)
	 printf("Renamed %s to %s.\n", newdatfile, datfile);
  else
	 perror("rename error!");
  printf("ڷ ϷǾϴ....\n");
  getch();
}
/* ȸ   ش. */
void list_member()
{
  FILE *fpi, *fpd;
  INDEX_REC idx;
  MEMBER_REC m;
  long i, nrec;

  fpi    = fopen(idxfile, "rb");    
  fpd    = fopen(datfile, "rb");    

  nrec = get_recount();
  for(i=0; i<nrec; i++) /* ü ڵ ŭ ݺ  */
  {
	/* read source index record */
	fseek(fpi, sizeof(INDEX_REC)*i, SEEK_SET);
	fread(&idx, sizeof(INDEX_REC), 1, fpi);
	if (idx.flag != 'D') {
	  /* read from data source file */
	  fseek(fpd, idx.offset, SEEK_SET);
	  fread(&m, sizeof(MEMBER_REC), 1, fpd);

	  /* display data */
	  display_member(&m);
	  printf("\n ƹŰ ʽÿ...\n");
	  getch();
	}
  }
  fclose(fpi);
  fclose(fpd);
}
/*   ش. */
void view_help()
{
  printf("----------------- HELP MESSAGE ---------------------------\n");
  printf("α׷ ó Ͻ   (member.idx)\n");
  printf(" (member.dat)  ʽϴ.\n");
  printf(", 'N'  ý ʱȭ  Ͻʽÿ.\n");
  printf(",    쿡  ۾ Ͻø  ͸\n");
  printf("Ҿ ǹǷ ؾ մϴ.\n");
  printf(" Ͱ  'X'  ڷḦ Ͻʽÿ.\n");
  printf("ڷḦ Ͻø  ˻ӵ ˴ϴ.\n");
  getch();
}
/* α׷ ŸƲ  Ѵ */
void printTitle(void)
{
	int i;
	char *t = "MMS(Membership Management System)  1 ܰ Ver 0.9";
	for (i=0; i<78;i++) putchar('=');
	printf("\n%s\n", t);
	for (i=0; i<78;i++) putchar('=');
	printf("\n\n");
}