#include <stdio.h>
#include <conio.h>
#include "member.h"
#include "text_lib.h"

char *datfile = "member.dat";  /*    */
char *idxfile = "member.idx";   /*    */

FIELDS fields = {  /* field xy : x, y, width, height */
  { 30,  3,  5, 1, REVERSE, {0,}, 0 }, /* no */
  { 30,  5, 10, 1, REVERSE, {0,}, 0 }, /* usrid */
  { 58,  5, 10, 1, REVERSE, {0,}, 0 }, /* paswd */
  { 30,  7, 15, 1, REVERSE, {0,}, 0 }, /* name */
  { 58,  7, 10, 1, REVERSE, {0,}, 0 }, /* sex */
  { 30,  9, 10, 1, REVERSE, {0,}, 0 }, /* age */
  { 30, 11, 10, 1, REVERSE, {0,}, 0 }, /* position */
  { 30, 13, 30, 1, REVERSE, {0,}, 0 }, /* company */
  { 30, 15, 40, 1, REVERSE, {0,}, 0 }, /* address */
  { 30, 17,  6, 1, REVERSE, {0,}, 0 }, /* zipcode */
  { 30, 19, 20, 1, REVERSE, {0,}, 0 }, /* tel */
  { 30, 21, 20, 1, REVERSE, {0,}, 0 }, /* cel */
};

/* ý ʱȭ */
void init_file()
{
	DFH dfh = {"MMS", "1.0", 0, 0, 0}; /* data file header */
	FILE* fp;
	dfh.version[3] = 0x1a; /* EOF to prevent read data file */
	if ((fp = fopen(datfile, "wb")) == NULL)
	{
	  alert("   !!");
	  exit(0);
	} else {
	  fwrite(&dfh, sizeof(dfh), 1, fp);
	}
	fclose(fp);
	if ((fp = fopen(idxfile, "wb")) == NULL)
	{
	  alert("  !!");
	  exit(0);
	}
	fclose(fp);
}

void init_memrec(MEMBER_REC *m)
{
  m->no = 0;
  memset(m->usrid, 0, strlen(m->usrid));
  memset(m->paswd, 0, strlen(m->paswd));
  memset(m->name, 0, strlen(m->name));
  memset(m->sex, 0, strlen(m->sex));
  m->age = 0;
  memset(m->position, 0, strlen(m->position));
  memset(m->company, 0, strlen(m->company));
  memset(m->address, 0, strlen(m->address));
  memset(m->zipcode, 0, strlen(m->zipcode));
  memset(m->tel, 0, strlen(m->tel));
  memset(m->cel, 0, strlen(m->cel));
}

/* get string from field */
int get_field(FIELD *f, FIELD_NO num)
{
  int i, ch, cx, cy;
  char quit=FALSE;
  cx = f->x + f->i;
  cy = f->y;
  cursor_on(14);
  if (cx-(f->x) >= f->w) cx--;  /* can't exceed max width */
  goto_xy(cx, cy);
  /*f->i = 0;*/
  while (TRUE)
  {
	ch = getch();
	if (ch==0)
	{
	  ch = getch();
	  switch (ch)
	  {
		case UP: case LEFT:
		  f->buf[f->i] = '\0';
		  num--;
		  /*if (num < NO) num = CEL;*/
		  if (mode == MODIFY && num < PASWD) num = CEL;
		  else if (mode == INSERT && num < USRID) num = CEL;
		  return num;
		case DOWN: case RIGHT:
		  f->buf[f->i] = '\0';
		  num++;
		  /* if (num > CEL) num = NO;*/
		  if (mode == MODIFY && num > CEL) num = PASWD;
		  else if (mode == INSERT && num > CEL) num = USRID;
		  return num;
		case F2: /* save */
		  f->buf[f->i] = '\0';
		  return F2;
	  }
	} else {
	  switch (ch)
	  {
		case ESC:  /* cancel input process */
		  quit = TRUE;
		  return -1;
		case ENTER: case '\t':
		  f->buf[f->i] = '\0';
		  num++;
		  /* if (num > CEL) num = NO;*/
		  if (mode == MODIFY && num > CEL) num = PASWD;
		  else if (mode == INSERT && num > CEL) num = USRID;
		  return num;
		case '\b':
		  /* erase current character */
		  goto_xy(cx, cy);
		  vcharxy(cx, cy, ' ', REVERSE);
		  goto_xy(cx, cy);
		  /* erase previous character */
		  cx--;
		  f->i--;
		  if (cx < f->x) {
			cx = f->x;
			f->i++;
		  } else {
			goto_xy(cx, cy);
			vcharxy(cx, cy, ' ', REVERSE);
			goto_xy(cx, cy);
			f->buf[f->i] = '\0';  /* erase the char in the buf */
		  }
		  break;
		default:
			f->buf[f->i] = ch;
			vcharxy(cx, cy, ch, REVERSE);
			cx++;
			f->i++;
			if (cx-(f->x) >= f->w) { /* check limit */
			  cx--;
			  f->buf[(f->i)--] = '\0';
			}
			goto_xy(cx, cy);
		  break;
	  }
	  if (quit) break;
	}  /* end of if */
  } /* end of while */
  cursor_off();
  return TRUE;
}

void insert_member()
{
  int num=USRID, i, ch, yes=0, quit=FALSE;
  MEMBER_REC m;
  init_memrec(&m);  /* init */
  set_field(NULL);  /* first vclear field */

  /* searial no auto increament */
  sprintf(fields.no.buf, "%ld", get_serial()+1);
  vprintfxy(fields.no.x, fields.no.y, DISABLE_COLOR, "%s", fields.no.buf);

  do
  {
	switch (num)
	{
	/*
	  case NO: num = get_field(&fields.no, num); break;
	  */
	  case USRID: num = get_field(&fields.usrid, num); break;
	  case PASWD: num = get_field(&fields.paswd, num); break;
	  case NAME: num = get_field(&fields.name, num); break;
	  case SEX: num = get_field(&fields.sex, num); break;
	  case AGE: num = get_field(&fields.age, num); break;
	  case POSITION: num = get_field(&fields.position, num); break;
	  case COMPANY: num = get_field(&fields.company, num); break;
	  case ADDRESS: num = get_field(&fields.address, num); break;
	  case ZIPCODE: num = get_field(&fields.zipcode, num); break;
	  case TEL: num = get_field(&fields.tel, num); break;
	  case CEL: num = get_field(&fields.cel, num); break;
	}
	if (num == -1) { /* quit input process */
	  set_field(NULL);
	  quit = TRUE;
	}
	if (num == F2) { /* save data */
	  yes = confirm(" Ͻðڽϱ?");
	  if (yes) {
		m.no = atol(fields.no.buf);
		strcpy(m.usrid, fields.usrid.buf);
		strcpy(m.paswd, fields.paswd.buf);
		strcpy(m.name, fields.name.buf);
		strcpy(m.sex, fields.sex.buf);
		m.age = atol(fields.age.buf);
		strcpy(m.position, fields.position.buf);
		strcpy(m.company, fields.company.buf);
		strcpy(m.address, fields.address.buf);
		strcpy(m.zipcode, fields.zipcode.buf);
		strcpy(m.tel, fields.tel.buf);
		strcpy(m.cel, fields.cel.buf);
		if (save_data(&m)) {
		  alert(" ϷǾϴ.");
		  set_field(NULL);
		}
		quit=TRUE;
	  } else num = 1; /* go usrid field */
	} /* end of save */
	if (quit) break;
  } while (TRUE);
  cursor_off();
}
/* get file header */
DFH get_filehead()
{
  FILE* fp;
  DFH dfh;
  fp = fopen(datfile, "rb");
  fseek(fp, 0L, SEEK_SET);
  fread(&dfh, sizeof(DFH), 1, fp);
  fclose(fp);
  return dfh;
}

int update_filehead(DFH dfh)
{
  FILE* fp;
  fp = fopen(datfile, "rb+");
  fseek(fp, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fp);
  fclose(fp);
  return TRUE;
}

/* get physical record count */
unsigned long get_recount()
{
  DFH dfh;
  dfh = get_filehead();
  return dfh.recnt;
}

/* get physical serial no */
unsigned long get_serial()
{
  DFH dfh;
  dfh = get_filehead();
  return dfh.serial;
}

void disk_swap(FILE *fp, unsigned long i, unsigned long j)
{
  INDEX_REC idx1, idx2;
  if (i == j) return;
  /* read idx1 */
  fseek(fp, sizeof(INDEX_REC)*i, SEEK_SET);
  fread(&idx1, sizeof(INDEX_REC), 1, fp);
  /* read idx2 */
  fseek(fp, sizeof(INDEX_REC)*j, SEEK_SET);
  fread(&idx2, sizeof(INDEX_REC), 1, fp);

  /* write idx2 on the positon of idx1 */
  fseek(fp, sizeof(INDEX_REC)*i, SEEK_SET);
  fwrite(&idx2, sizeof(INDEX_REC), 1, fp);
  /* write idx1 on the positon of idx2 */
  fseek(fp, sizeof(INDEX_REC)*j, SEEK_SET);
  fwrite(&idx1, sizeof(INDEX_REC), 1, fp);
}

int disk_comp(FILE* fp, unsigned long i, unsigned long j)
{
  INDEX_REC idx1, idx2;
  /* read idx1 */
  fseek(fp, sizeof(INDEX_REC)*i, SEEK_SET);
  fread(&idx1, sizeof(INDEX_REC), 1, fp);
  /* read idx2 */
  fseek(fp, sizeof(INDEX_REC)*j, SEEK_SET);
  fread(&idx2, sizeof(INDEX_REC), 1, fp);
  /* compare usrid */
  return strcmp(idx1.usrid, idx2.usrid);
}

/* Quick Sort on the disk with fp */
void fqsort(FILE *fp, long left, long right)
{
  long i, last;
  if (left >= right) return;
  disk_swap(fp, left, (left+right)/2);
  last = left;
  for (i=left+1; i<=right; i++)
  {
	if (disk_comp(fp, i, left) < 0)
	  disk_swap(fp, ++last, i);
  }
  disk_swap(fp, left, last);
  fqsort(fp, left, last-1);
  fqsort(fp, last+1, right);
}
/* binary search */
long fbin_search(const char* key, long n, FILE* fp)
{
  int cond;
  long low = 0L, high = n, mid;
  INDEX_REC idx;

  while (low < high)
  {
	mid = (low + high) / 2;
	fseek(fp, sizeof(INDEX_REC)*mid, SEEK_SET);
	fread(&idx, sizeof(INDEX_REC), 1, fp);
	cond = strcmp(key, idx.usrid);
	if (cond < 0) high = mid;
	else if (cond > 0) low = mid + 1;
	else return mid; /* return the index of searched data */
  }
  return EOF;  /* Not found */
}

int save_data(MEMBER_REC *m)
{
  FILE *fp;
  DFH dfh;
  INDEX_REC idx;
  long n;
  unsigned long offset = 0L;

  fp = fopen(datfile, "rb+");
  if (!fp) {
	alert("   !!");
	exit(0);
  }
  n = find_member(m->usrid,m);
  if (n!=EOF) {
	alert("̹ ϴ ȸIDԴϴ.");
	fclose(fp);
	return FALSE;
  }
  fseek(fp, 0L, SEEK_SET);
  fread(&dfh, sizeof(DFH), 1, fp);  /* read file header */
  /* seek the postion to write */
  offset = sizeof(MEMBER_REC)*dfh.recnt + sizeof(DFH); /* offset from first */
  fseek(fp, offset, SEEK_SET);
  fwrite(m, sizeof(MEMBER_REC), 1, fp);
  fflush(fp);
  dfh.recnt++;  /* increase record count and then write header */
  dfh.serial++; /* increase serial */
  fseek(fp, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fp); /* write head for updating recnt */
  fclose(fp);

  strcpy(idx.usrid, m->usrid);  /* copy usrid to the field of idx file */
  idx.offset = offset;          /* offset to datfile */
  idx.flag = '\0';              /* deleting flag initial value */
  fp = fopen(idxfile, "rb+");
  if (!fp) {
	alert("  !!");
	exit(0);
  }
  fseek(fp, sizeof(INDEX_REC)*(dfh.recnt-1), SEEK_SET);
  fwrite(&idx, sizeof(INDEX_REC), 1, fp); /* write index */
  fflush(fp);

  fqsort(fp, 0, dfh.recnt-1);  /* quick sort index on the disk */
  fclose(fp);

  return TRUE;
}

void modify_member()
{
  FILE* fp;
  int num=PASWD, i, ch, yes=0, quit=FALSE;
  MEMBER_REC m;
  init_memrec(&m);
  if (strlen(fields.no.buf) == 0 || strlen(fields.usrid.buf) == 0)
  {
	alert(" ڵ尡 õ ʾҽϴ.");
	return;
  }
  /* no & usrid are not modified... */
  vprintfxy(fields.no.x, fields.no.y, DISABLE_COLOR, "%s", fields.no.buf);
  vprintfxy(fields.usrid.x, fields.usrid.y, DISABLE_COLOR, "%s", fields.usrid.buf);
  do {
	switch (num)
	{
	/*
	  case NO: num = get_field(&fields.no, num); break;
	  case USRID: num = get_field(&fields.usrid, num); break;
	*/
	  case PASWD: num = get_field(&fields.paswd, num); break;
	  case NAME: num = get_field(&fields.name, num); break;
	  case SEX: num = get_field(&fields.sex, num); break;
	  case AGE: num = get_field(&fields.age, num); break;
	  case POSITION: num = get_field(&fields.position, num); break;
	  case COMPANY: num = get_field(&fields.company, num); break;
	  case ADDRESS: num = get_field(&fields.address, num); break;
	  case ZIPCODE: num = get_field(&fields.zipcode, num); break;
	  case TEL: num = get_field(&fields.tel, num); break;
	  case CEL: num = get_field(&fields.cel, num); break;
	}
	if (num == -1) { /* quit input process */
	  set_field(NULL);
	  quit = TRUE;
	}
	if (num == F2) { /* save data */
	  yes = confirm(" Ͻðڽϱ?");
	  if (yes) {
		m.no = atol(fields.no.buf);
		strcpy(m.usrid, fields.usrid.buf);
		strcpy(m.paswd, fields.paswd.buf);
		strcpy(m.name, fields.name.buf);
		strcpy(m.sex, fields.sex.buf);
		m.age = atol(fields.age.buf);
		strcpy(m.position, fields.position.buf);
		strcpy(m.company, fields.company.buf);
		strcpy(m.address, fields.address.buf);
		strcpy(m.zipcode, fields.zipcode.buf);
		strcpy(m.tel, fields.tel.buf);
		strcpy(m.cel, fields.cel.buf);

        /* write modifed record to the data file */
        fp = fopen(datfile, "rb+");
        fseek(fp, get_offset(m.usrid), SEEK_SET);
        fwrite(&m, sizeof(MEMBER_REC), 1, fp);
        fclose(fp);

		alert(" ϷǾϴ...");
		set_field(NULL);
		quit=TRUE;
	  }
	} /* end of save */
	if (quit) break;
  } while (TRUE);
  cursor_off();
}

void display_member(MEMBER_REC *m)
{
  set_field(m);  /* first vclear field */
}

int set_delete(const char* usrid)
{
  FILE* fp;
  DFH dfh;
  INDEX_REC idx;
  long n;

  fp = fopen(idxfile, "rb+");
  n = fbin_search(usrid, get_recount(), fp);
  if (n == EOF) {
	fclose(fp);
	return FALSE;
  }

  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fread(&idx, sizeof(INDEX_REC), 1, fp);
  idx.flag = 'D';  /* mark 'D' means it's deleted.. */
  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fwrite(&idx, sizeof(INDEX_REC), 1, fp);

  dfh = get_filehead();
  dfh.delcnt++;
  update_filehead(dfh);

  fclose(fp);
  return TRUE;
}
/* get offset in the datfile */
unsigned long get_offset(const char* usrid)
{
  FILE* fp;
  INDEX_REC idx;
  long n;

  fp = fopen(idxfile, "rb+");
  n = fbin_search(usrid, get_recount(), fp);
  if (n == EOF) {
	fclose(fp);
	return EOF;
  }

  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fread(&idx, sizeof(INDEX_REC), 1, fp);
  fclose(fp);

  return idx.offset;
}

void delete_member(char *usrid)
{
  FILE* fp;
  MEMBER_REC m;
  long n;

  n = find_member(usrid, &m);
  if (n==EOF) {
	alert(" ڷḦ ã  ϴ.");
	return;
  }
  set_delete(usrid);
}

long find_member(const char* usrid, MEMBER_REC *m)
{
  FILE* fp;
  INDEX_REC idx;
  long n;

  fp = fopen(idxfile, "rb");
  n = fbin_search(usrid, get_recount(), fp);
  if (n == EOF) {
	fclose(fp);
	return EOF;
  }

  fseek(fp, sizeof(INDEX_REC)*n, SEEK_SET);
  fread(&idx, sizeof(INDEX_REC), 1, fp);
  fclose(fp);

  if (idx.flag == 'D') return EOF;  /* exists but deleted */

  fp = fopen(datfile, "rb");
  fseek(fp, idx.offset, SEEK_SET);
  fread(m, sizeof(MEMBER_REC), 1, fp);
  fclose(fp);

  return n;  /* index position */
}

void search_member()
{
  MEMBER_REC m;
  char usrid[20], *str;
  long n;

  str = prompt("˻ ȸ ID ԷϽʽÿ!");
  strcpy(usrid, str);
  if (strlen(usrid)==0) return;
  n = find_member(usrid, &m);
  if (n==EOF) {
	alert(" ʴ ȸID Դϴ.");
	return;
  }
  list_member(n);
}

int indexing()
{
  FILE *fpi, *fpinew;
  FILE *fpd, *fpdnew;
  INDEX_REC idx;
  MEMBER_REC m;
  DFH dfh = get_filehead();
  long nioff = 0L, ndoff = 0L, i, nrec, wcnt=0L;
  char* newidxfile = "nmember.idx";
  char* newdatfile = "nmember.dat";

  fpi    = fopen(idxfile, "rb");        /* source index file */
  fpd    = fopen(datfile, "rb");        /* source data file */
  fpinew = fopen(newidxfile, "wb+");    /* new index file */
  fpdnew = fopen(newdatfile, "wb+");    /* new data file */

  /* write header for new data file */
  dfh.version[3] = 0x1a;  /* EOF  */
  fseek(fpdnew, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fpdnew);

  nrec = get_recount();
  for(i=0; i<nrec; i++)
  {
	/* read source index record */
	fseek(fpi, sizeof(INDEX_REC)*i, SEEK_SET);
	fread(&idx, sizeof(INDEX_REC), 1, fpi);
	if (idx.flag != 'D') {
	  /* read from data source file */
	  fseek(fpd, idx.offset, SEEK_SET);
	  fread(&m, sizeof(MEMBER_REC), 1, fpd);
	  /* write to new data file */
	  ndoff = sizeof(MEMBER_REC) * wcnt + sizeof(DFH);  /* new data file offset */
	  fseek(fpdnew, ndoff, SEEK_SET);
	  fwrite(&m, sizeof(MEMBER_REC), 1, fpdnew);
	  /* write to new index file */
	  idx.offset = ndoff;
	  nioff = sizeof(INDEX_REC) * wcnt;  /* new index file offset */
	  fseek(fpinew, nioff, SEEK_SET);
	  fwrite(&idx, sizeof(INDEX_REC), 1, fpinew);
	  wcnt++;   /* increate written count */
	}
  }
  /* write header of the new data file */
  dfh.recnt = wcnt;  /* writtened record count */
  dfh.delcnt = 0;
  /* dfh.serial ; dfh.serial is must reamined... */
  fseek(fpdnew, 0L, SEEK_SET);
  fwrite(&dfh, sizeof(DFH), 1, fpdnew);

  fflush(NULL);
  fclose(fpi);
  fclose(fpd);
  fclose(fpinew);
  fclose(fpdnew);

  /* delete the file */
  if (remove(idxfile) != 0) return FALSE;
  if (remove(datfile) != 0) return FALSE;
  /* Rename the newly generated file */
  if (rename(newidxfile, idxfile) != 0) return FALSE;
  if (rename(newdatfile, datfile) != 0) return FALSE;
  return TRUE;
}

void list_member(long i)
{
  FILE *fpi, *fpd;
  INDEX_REC idx;
  MEMBER_REC m;
  long nrec;
  char ch=PGDN, quit=FALSE, yes;

  fpi    = fopen(idxfile, "rb");        /* source index file */
  fpd    = fopen(datfile, "rb");        /* source data file */

  nrec = get_recount();
  if (nrec <= 0) {
	alert("ڷᰡ ϳ ϴ.");
	return;
  }
/*  i = 0;*/
  do
  {
	/* read source index record */
	fseek(fpi, sizeof(INDEX_REC)*i, SEEK_SET);
	fread(&idx, sizeof(INDEX_REC), 1, fpi);
	if (idx.flag == 'D') { /* skip deleted record */
	  switch (ch)  {
		case PGUP:
		  i--;
		  if (i < 0) i = 0;
		  continue;
		case PGDN:
		  i++;
		  if (i >= nrec) i = nrec - 1;
		  continue;
	  }
	} else {
	  /* read from data source file */
	  fseek(fpd, idx.offset, SEEK_SET);
	  fread(&m, sizeof(MEMBER_REC), 1, fpd);

	  /* display data */
	  display_member(&m);
	}
	ch = getch();
	if (ch == 0) ch = getch();
	switch (ch)
	{
	  case PGUP:
		i--;
		if (i < 0) i = 0;
		break;
	  case PGDN:
		i++;
		if (i >= nrec) i = nrec - 1;
		break;
	  case F5: /* modify */
		modify_member();
		break;
	  case F8: /* delete */
		yes = confirm(" Ͻðڽϱ?");
		if (yes) {
		  delete_member(m.usrid);
		  print_recinfo();
		  i=0;  /* rewind */
		}
		break;
	  case ESC:
		set_field(NULL);
		quit = TRUE;
		break;
	}
	if (quit) break;
  } while (TRUE);
  fclose(fpi);
  fclose(fpd);

}

/* create text field */
void make_field(FIELD *f)
{
	int i, j;
	for(i=0; i<f->w; i++)
	  for (j=0; j<f->h; j++)
		vcharxy(f->x+i, f->y+j, ' ', f->a);

	memset(f->buf, 0, sizeof(f->buf));
	f->i = 0;
}

void clear_field(FIELD_NO no)
{
	switch (no)
	{
	  case NO : make_field(&fields.no); break;
	  case USRID : make_field(&fields.usrid); break;
	  case PASWD : make_field(&fields.paswd); break;
	  case NAME : make_field(&fields.name); break;
	  case SEX : make_field(&fields.sex); break;
	  case AGE : make_field(&fields.age); break;
	  case POSITION : make_field(&fields.position); break;
	  case COMPANY : make_field(&fields.company); break;
	  case ADDRESS : make_field(&fields.address); break;
	  case ZIPCODE : make_field(&fields.zipcode); break;
	  case TEL : make_field(&fields.tel); break;
	  case CEL : make_field(&fields.cel); break;
	}
}

void set_field(MEMBER_REC *m)
{
	char attr = REVERSE; /*WHITE|(BLUE<<4);*/
	FIELD_NO f;
	for (f=NO; f<=CEL; f++) clear_field(f);
	if (m) {
	  vprintfxy(fields.no.x, fields.no.y, attr, "%d", m->no);
	  vprintfxy(fields.usrid.x, fields.usrid.y, attr, "%s", m->usrid);
	  vprintfxy(fields.paswd.x, fields.paswd.y, attr, "%s", m->paswd);
	  vprintfxy(fields.name.x, fields.name.y, attr, "%s", m->name);
	  vprintfxy(fields.sex.x, fields.sex.y, attr, "%s", m->sex); /* sex */
	  vprintfxy(fields.age.x, fields.age.y, attr, "%d", m->age); /* age */
	  vprintfxy(fields.position.x, fields.position.y, attr, "%s", m->position); /* position */
	  vprintfxy(fields.company.x, fields.company.y, attr, "%s", m->company); /* company */
	  vprintfxy(fields.address.x, fields.address.y, attr, "%s", m->address); /* address */
	  vprintfxy(fields.zipcode.x, fields.zipcode.y, attr, "%s", m->zipcode); /* zipcode */
	  vprintfxy(fields.tel.x, fields.tel.y, attr, "%s", m->tel); /* tel */
	  vprintfxy(fields.cel.x, fields.cel.y, attr, "%s", m->cel); /* cel */

	  sprintf(fields.no.buf, "%d", m->no);
	  fields.no.i = strlen(fields.no.buf);

	  strcpy(fields.usrid.buf, m->usrid);
	  fields.usrid.i = strlen(fields.usrid.buf);

	  strcpy(fields.paswd.buf, m->paswd);
	  fields.paswd.i = strlen(fields.paswd.buf);

	  strcpy(fields.name.buf, m->name);
	  fields.name.i = strlen(fields.name.buf);

	  strcpy(fields.sex.buf, m->sex);
	  fields.sex.i = strlen(fields.sex.buf);

	  sprintf(fields.age.buf, "%d", m->age);
	  fields.age.i = strlen(fields.age.buf);

	  strcpy(fields.position.buf, m->position);
	  fields.position.i = strlen(fields.position.buf);
	  
	  strcpy(fields.company.buf, m->company);
	  fields.company.i = strlen(fields.company.buf);
	  
	  strcpy(fields.address.buf, m->address);
	  fields.address.i = strlen(fields.address.buf);
	  
	  strcpy(fields.zipcode.buf, m->zipcode);
	  fields.zipcode.i = strlen(fields.zipcode.buf);
	  
	  strcpy(fields.tel.buf, m->tel);
	  fields.tel.i = strlen(fields.tel.buf);
	  
	  strcpy(fields.cel.buf, m->cel);
	  fields.cel.i = strlen(fields.cel.buf);
	}
}
