/*
	PROGRAM NAME : MMS.C
	Author: IL Kwang, KIM.
*/
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include "text_lib.h"
#include "member.h"
#include "mms.h"
MODE mode;
static MENU_INFO Main_menu[MAX_MAIN_MENU] = {
	  { NULL, NULL, NULL },  /* not used */
	  { " ȸ  F1 ", 1,  5 },
	  { " ȸ˻  F3 ", 1,  6 },
	  { " ȸ  F4 ", 1,  7 },
	  { "   F5 ", 1,  8 },
	  { " ڷ  F6 ", 1,  9 },
	  { " ʱȭ    F7 ", 1, 10 },
	  { "      ESC ", 1, 11 },
};

void main()
{
	int preno=1, quit=FALSE, yes;
	set_vmode();
	cursor_off();
	vclear();
	draw_main_menu();
	draw_panel();  /* draw inforamtion panel */

	do {
	  switch (preno=select_menu(MAX_MAIN_MENU, preno, Main_menu)) {
		case 1:
		  mode = INSERT;
		  insert_member();
		  break;
		case 2:
		  mode = SEARCH;
		  search_member();
		  break;
		case 3:
		  mode = LIST;
		  list_member(0); /* from the first */
		  break;
		case 4:
		  mode = MODIFY;
		  modify_member();
		  break;
		case 5:
		  mode = INDEXING;
		  yes = confirm("ڷḦ ϸ ˻ӵ ϴ!");
		  if (yes)
		  {
		    if (indexing()==FALSE)
			  alert("ڷ  ߻߽ϴ.");
		    else
			  alert("ڷ ϷǾϴ.");
		  }
		  break;
		case 6:
		  mode = INITDATA;
		  init_system();
		  break;
		case 7: quit = TRUE; break;
	  }
	  print_recinfo(); /* update screen rec info */
	  if (quit) break;
	} while (TRUE);

} /* end of main */

void draw_panel()
{
	char *field[] ={
	  "No.", "User ID ", "йȣ ", "  ", "  ", "  ", "  ",
	  "ȸ ", "  ", "ȣ ", " ȭ ", "޴ "
	};
	char attr = WHITE|(BLUE<<4);
	int sx1, sx2, ex1, ex2, sy1, sy2, ey1, ey2;
	sx1= 0; sy1=2; ex1=15; ey1=22;
	sx2=18; sy2=2; ex2=77; ey2=22;
	/* make information panel */
	make_box(sx1, sy1, ex1, ey1, attr, 0);
	shade_box(sx1, sy1, ex1, ey1, 2, 1, SHADE_COLOR);

	make_box(sx2, sy2, ex2, ey2, attr, 0);
	shade_box(sx2, sy2, ex2, ey2, 2, 1, SHADE_COLOR);

	vprintfxy(1, 3, YELLOW|(MAGENTA<<4), "     M.M.S    ");
	write_menu(MAX_MAIN_MENU, Main_menu);
	print_recinfo(); /* update screen rec info */

	vprintfxy(sx2+2, sy2+1, attr, "%10s", field[0]); /* no */
	vprintfxy(sx2+2, sy2+3, attr, "%10s", field[1]); /* usrid */
	vprintfxy(sx2+30, sy2+3, attr, "%10s", field[2]); /* paswd */
	vprintfxy(sx2+2, sy2+5, attr, "%10s", field[3]); /* name */
	vprintfxy(sx2+30, sy2+5, attr, "%10s", field[4]); /* sex */
	vprintfxy(sx2+2, sy2+7, attr, "%10s", field[5]); /* age */
	vprintfxy(sx2+2, sy2+9, attr, "%10s", field[6]); /* position */
	vprintfxy(sx2+2, sy2+11, attr, "%10s", field[7]); /* company */
	vprintfxy(sx2+2, sy2+13, attr, "%10s", field[8]); /* address */
	vprintfxy(sx2+2, sy2+15, attr, "%10s", field[9]); /* zipcode */
	vprintfxy(sx2+2, sy2+17, attr, "%10s", field[10]); /* tel */
	vprintfxy(sx2+2, sy2+19, attr, "%10s", field[11]); /* cel */

	vprintfxy(sx2+50, sy2+5, attr, "(eg,M/F)");
	vprintfxy(sx2+20, sy2+15, attr, "(eg, 704360)");

	set_field(NULL);  /* vclear field */

	vprintfxy(54, 19, YELLOW|(BLUE<<4),"%s", "ESC: Quit");
	vprintfxy(54, 20, YELLOW|(BLUE<<4),"%s", "F2: Save, F8: Delete");
	vprintfxy(54, 21, YELLOW|(BLUE<<4),"%s", "PgUP: Prev, PgDN: Next");
}

void print_recinfo()
{
	FILE* fp;
	DFH dfh;
	fp = fopen(datfile, "rb");
	fseek(fp, 0L, SEEK_SET);
	fread(&dfh, sizeof(DFH), 1, fp);
	fclose(fp);
	vprintfxy(2, 14, WHITE|(BLUE<<4), "Tot:%5ld", dfh.recnt);
	vprintfxy(2, 15, WHITE|(BLUE<<4), "Del:%5ld", dfh.delcnt);
	vprintfxy(2, 16, WHITE|(BLUE<<4), "----------");
	vprintfxy(2, 17, WHITE|(BLUE<<4), "Rec:%5ld", dfh.recnt - dfh.delcnt);
}

void draw_main_menu()
{
	register int i, j;

	for (i=0; i<80; i++) {
	   vcharxy(i,  0, ' ', TOP_NORMAL);
	   vcharxy(i, 24, ' ', TOP_NORMAL);
	}

	vputs(18,  0, " MMS(Membership Management System) Ver 1.0 ", TOP_NORMAL);
	vputs(18, 24, " HANBIT MEDIA IT CooK BooK, C Programming. ", TOP_NORMAL);

	for (i=1; i<24; i++)
	  for (j=0; j<80; j+=2) {  /* + */
		 vcharxy(j, i, 0xa6, BACGRD);
		 vcharxy(j+1, i, 0xc0, BACGRD);
	  }
 /*		 vcharxy(j, i, 177, BACGRD);*/

	shade_box(0, 0, 79, 0, 0, 1, SHADE_COLOR);
}

/* it careats new data file and index file ... */
void init_system()
{
	char ch;
	ch = confirm(" ڷḦ ϰ ʱȭմϴ!");
	if (ch==TRUE) init_file();  /* init system */
}

int select_menu(int mcnt, int crnt, MENU_INFO *menu)
{
	int no=crnt, max;
	char ch;

    max = mcnt-1;
	write_item_inv(no, menu);

	do {
	  if ((ch=getch())==0) {
		 switch (ch=getch()) {
		   case UP: case LEFT:
			 write_item(no, menu);
			 if (--no<1) no = max;
			 write_item_inv(no, menu);
			 break;
		   case DOWN: case RIGHT:
			 write_item(no, menu);
			 if (++no>max) no = 1;
			 write_item_inv(no, menu);
			 break;
		  case F1: /* insert member */
			write_item(no, menu);
			no = 1;
			write_item_inv(no, menu);
			return no;
		  case F3: /* search member */
			write_item(no, menu);
			no = 2;
			write_item_inv(no, menu);
			return no;
		  case F4: /* list member */
			write_item(no, menu);
			no = 3;
			write_item_inv(no, menu);
			return no;
		  case F5: /* modify member */
			write_item(no, menu);
			no = 4;
			write_item_inv(no, menu);
			return no;
		  case F6: /* inexing */
			write_item(no, menu);
			no = 5;
			write_item_inv(no, menu);
			return no;
		  case F7: /* init */
			write_item(no, menu);
			no = 6;
			write_item_inv(no, menu);
			return no;
		 }
	  } else {
		 switch (ch) {
		   case ESC: return 7;
		   case ENTER: return no;
		 }
	  }
	} while(TRUE);
}

void write_menu(unsigned mcnt, MENU_INFO *menu)
{
	int i, loopcnt;

	loopcnt = mcnt;

	for (i=1; i<loopcnt; i++)
	vprintfxy((menu+i)->sx, (menu+i)->sy, YELLOW|(BLUE<<4),"%s",(menu+i)->item);
}

void write_item_inv(unsigned no, MENU_INFO *menu)
{
	vprintfxy((menu+no)->sx, (menu+no)->sy, BLACK|(CYAN<<4),"%s",(menu+no)->item);
}

void write_item(unsigned no, MENU_INFO *menu)
{
	vprintfxy((menu+no)->sx, (menu+no)->sy, YELLOW|(BLUE<<4),"%s",(menu+no)->item);
}
