#include <stdio.h>
#define MAX_STUDENT 3
struct STUDENT {
  int no;
  char name[20];
  char sex, tel[15], major[30];
  struct {
	char date[20];
	int kor, eng, math;
	float avg;
  } score;
};
char *format = "%2d %6s %3c %13s %20s %10s %3d %3d %3d  %3.2f\n";

void printTitle(void);
void printStudent(struct STUDENT st);
void printAllStudent(struct STUDENT *p);

int main()
{
  int i;
  struct STUDENT *p;
  struct STUDENT st[MAX_STUDENT] = {
	{ 1, "Kim", 'M', "010-234-1234", "Computer Science",
	 {"2004-02-19", 80, 90, 75, 81.67} },
	{ 2, "Park", 'M', "016-123-3034", "Computer Science",
	 {"2004-02-19", 78, 88, 75, 83.67} },
	{ 3, "Lee", 'F', "011-808-3082", "Medical Information",
	 {"2004-02-10", 79, 92, 65, 78.67} }
  };

  p = st;

  printTitle();
  printStudent(st[0]);
  printAllStudent(p);

  return 0;
}
void printTitle(void)
{
  int i;
  char *t[] = {
   "NO","NAME","SEX","TELEPHONE","MAJOR","EXAM_DATE","KOR","ENG","MATH","AVG"
  };
  for (i=0; i<78;i++) putchar('=');
  printf("\n%2s %6s %3s %13s %20s %10s %3s %3s %3s %3s\n", t[0], t[1], t[2], t[3], t[4], t[5], t[6], t[7], t[8], t[9]);
  for (i=0; i<78;i++) putchar('=');
  printf("\n");
}
void printStudent(struct STUDENT st)
{
  int i;
  printf(format, st.no, st.name, st.sex, st.tel, st.major, st.score.date, st.score.kor, st.score.eng, st.score.math, st.score.avg);
  printf("sizeof(st) = %d\n", sizeof(st));
}
void printAllStudent(struct STUDENT *p)
{
  int i;
  for (i=0; i<MAX_STUDENT; i++, p++)
	printf(format, p->no, p->name, p->sex, p->tel, p->major, p->score.date, p->score.kor, p->score.eng, p->score.math, p->score.avg);
  printf("sizeof(p) = %d\n", sizeof(p));
}