#include <stdio.h>
#define MAX_RATE     1.3
#define MID_RATE     1.2
#define MIN_RATE     1.1
#define PAY_PER_HOUR 38000
void printPayRule();
unsigned long caclPayment(int, int);
int main()
{
	int score, hours;
	printPayRule();
	printf("Input score & hours: ");
	scanf("%d %d", &score, &hours);
	printf("Your income = %10ld\n", caclPayment(score,hours));
	return 0;
}
unsigned long caclPayment(int score, int hours)
{
	float rate;
	if (score >= 100) rate = MAX_RATE;
	else if (score >= 90 && score < 100) rate = MID_RATE;
	else if (score >= 80 && score < 90) rate = MIN_RATE;
	else rate = 1.0f;
	return (unsigned long)( hours * PAY_PER_HOUR * rate );
}
void printPayRule()
{
  printf("<< Pay Rule >>\n");
  printf("Pay per hour : %ld\n", PAY_PER_HOUR);
  printf("score == 100 : hours * %ld * %1.1f\n", PAY_PER_HOUR, MAX_RATE);
  printf("score >=  90 : hours * %ld * %1.1f\n", PAY_PER_HOUR, MID_RATE);
  printf("score >=  80 : hours * %ld * %1.1f\n", PAY_PER_HOUR, MIN_RATE);
}