#include <stdio.h>
int main(int argc, char *argv[])
{
  char ch;
  FILE *fin;
  unsigned int size = 0;
  if (argc != 2) {
	printf("Usage: ch09_07 <text-file-name>\n");
	exit(1);
  }
  fin = fopen(argv[1], "r");
  if (!fin) {
	printf("File Open Error : %s\n", argv[1]);
	exit(1);
  }
  while( (ch=fgetc(fin)) != EOF )
  {
	putchar(ch);
	if (ch == '\n') size++;
	size++;
  }
  fclose(fin);
  printf("\n\nFile name: %s\n", argv[1]);
  printf("File size: %d bytes\n", size);
  return 0;
}