#include <stdio.h>
int main(char argc, char *argv[])
{
  char ch, *p;
  FILE *fin, *fout;
  if (argc < 3) {
	printf("mycp <srcfile> <destfile>\n");
	exit(1);
  }
  fin = fopen(argv[1], "r");
  if (!fin)
  {
	printf("File Open Error\n");
	exit(1);
  }
  fout = fopen(argv[2], "w");
  if (!fout) {
	printf("File Open Error\n");
	exit(1);
  }
  while( (ch=fgetc(fin)) != EOF )
  {
	fputc(ch, fout);
  }
  fclose(fin);
  fclose(fout);
  printf("File Copied...\n");
  return 0;
}